﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

namespace LINQtoSQL
{
    public partial class _Default : System.Web.UI.Page
    {
protected void Page_Load(object sender, EventArgs e)
{
    

}

private void ShowProducts()
{
    NorthwindDataContext db = new NorthwindDataContext();

    var products = from p in db.Products
                   where p.Supplier.CompanyName == "Tokyo Traders"
                   orderby p.ProductID descending
                   select new {p.ProductID, p.ProductName, p.Supplier.CompanyName,Price = p.UnitPrice };

    grdProducts.DataSource = products;
    grdProducts.DataBind();
}

protected void Select_Click(object sender, EventArgs e)
{
    ShowProducts();
}

protected void Insert_Click(object sender, EventArgs e)
{
    NorthwindDataContext db = new NorthwindDataContext();

    Product newProduct = new Product { SupplierID = 4,
                                       ProductName = "Nagashi",
                                       UnitPrice = 2.90m };
   
    db.Products.InsertOnSubmit(newProduct);
    db.SubmitChanges();
    ShowProducts();
}

protected void Update_Click(object sender, EventArgs e)
{
    NorthwindDataContext db = new NorthwindDataContext();

    Product product = db.Products.First(p => p.ProductName.Equals("Nagashi"));
    product.UnitPrice += 0.10m;
    db.SubmitChanges();
    ShowProducts();
}

protected void Delete_Click(object sender, EventArgs e)
{
    NorthwindDataContext db = new NorthwindDataContext();

    Product product = db.Products.First(p => p.ProductName.Equals("Nagashi"));
    db.Products.DeleteOnSubmit(product);
    db.SubmitChanges();
    ShowProducts();
}

protected void Debug_Click(object sender, EventArgs e)
{
    NorthwindDataContext db = new NorthwindDataContext();

    var products = from p in db.Products
                   where p.Supplier.CompanyName == "Tokyo Traders"
                   orderby p.ProductID descending
                   select p;
   
    grdProducts.DataSource = products;
    grdProducts.DataBind();
}



    }
}
