﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace LINQtoXML
{
    class Program
    {
        static void Main(string[] args)
        {
            // unmark a sample and run.
            sample1();
            //sample2();
            //sample3();
            //sample4();
            //sample5();
            //sample6();
            //sample7();
            //sample8();
            //sample9();
            //sample10();
            //sample11();
            //sample12();
        }

        static void sample1()
        {
            XDocument products =
                  new XDocument(                            // יצירת מסמך
                    new XElement("Products",                // יצירת אלמנט ראשי 
                      new XElement("Name", "ThinkPad X61"), // יצירת אלמנט
                      new XElement("Name", "ThinkPad T71")  // יצירת אלמנט
                      )
                   );
            products.Save("ProductsFile.xml");                  // שמירה לקובץ

            XDocument LoadedProducts = XDocument.Load("ProductsFile.xml");

            Console.WriteLine(LoadedProducts);                  // הצגת המסמך

        }

        static void sample2()
        {
            XDocument products =
                      new XDocument(
                        new XElement("Products",

                            new XElement("Product",
                                new XElement("ID", "98765"),
                                new XElement("Name", "ThinkPad X61")),

                            new XElement("Product",
                                new XElement("ID", "98760"),
                                new XElement("Name", "ThinkPad X71"),
                                new XElement("Price", "3250"))

                            )
                       );

            Console.WriteLine(products);                  

        }

        static void sample3()
        {
            XDocument products =
                  new XDocument(
                    new XElement("Products",

                        new XElement("Product",
                            new XElement("ID", "98765"),
                            new XElement("Name", "ThinkPad X61"),
                            new XElement("Contact", "David"),
                            new XElement("Contact", "Meir")),


                        new XElement("Product",
                            new XElement("ID", "98760"),
                            new XElement("Name", "ThinkPad X71"),
                            new XElement("Price", "3250"),
                            new XElement("Contact", "Ravid"))

                        )
                   );

            // Products קבל את האלמנט הראשון בשם 
            XElement root = products.Element("Products");
            IEnumerable<XElement> myProducts = root.Elements();

            foreach (XElement myProd in myProducts)
            {
                // Name קבל את האלמנט הראשון בשם 
                XElement prodNameNode = myProd.Element("Name");
                Console.WriteLine(prodNameNode.Value);

                // Contact קבל את האלמנט הראשון בשם 
                IEnumerable<XElement> prodContact = myProd.Elements("Contact");
                foreach (XElement contact in prodContact)
                {
                    Console.WriteLine("   {0}", contact.Value);
                }
            }

        }

        static void sample4()
        {
            // בניית עץ
            XDocument xDoc = new XDocument(
                new XElement("ROOT", new XElement("NODE_01")
                )
            );

            Console.WriteLine("I have one node:");
            Console.WriteLine(xDoc);

            // קבל הפנייה לעץ
            XElement myRoot = xDoc.Element("ROOT");

            // הוספת בן בודד לעץ
            myRoot.Add(new XElement("NODE_02"));

            // הוספת מספר בנים לעץ
            myRoot.Add(new XElement("NODE_03"),
                        new XComment("this is a comment"),
                        new XElement("NODE_04"));

            Console.WriteLine();
            Console.WriteLine(".. and now I have four nodes:");
            Console.WriteLine(xDoc);

        }

        static void sample5()
        {
            XDocument xDoc = new XDocument(
                new XElement("ROOT",
                  new XAttribute("YEAR", "2008"), // בנאי המאפיין
                  new XAttribute("TOTAL", "2"),    // בנאי המאפיין
                new XElement("NODE_01"),
                new XElement("NODE_02")
                )
            );

            Console.WriteLine(xDoc);
        }

        static void sample6()
        {
            XDocument xDoc = new XDocument(
                new XElement("ROOT",
                  new XAttribute("YEAR", "2008"),
                  new XAttribute("TOTAL", "2"),
                new XElement("NODE_01"),
                new XElement("NODE_02")
                )
            );

            Console.WriteLine(xDoc);

            XElement myRoot = xDoc.Element("ROOT");

            XAttribute total = myRoot.Attribute("TOTAL");
            XAttribute year = myRoot.Attribute("YEAR");

            Console.WriteLine("Year  is: {0}", year.Value);
            Console.WriteLine("Total is: {0}", total.Value);

        }

        static void sample7()
        {
            XDocument xDoc = new XDocument(
                new XElement("ROOT",
                    new XAttribute("YEAR", "2008"),
                    new XAttribute("TOTAL", "2"),
                    new XElement("NODE_01"),
                    new XElement("NODE_02")
                )
            );

            XElement myRoot = xDoc.Element("ROOT");

            myRoot.Attribute("TOTAL").Remove();	        // TOTAL הסר מאפיין 
            myRoot.SetAttributeValue("YEAR", null); 	// YEAR הסר מאפיין

            Console.WriteLine(xDoc);

        }

        static void sample8()
        {
            XDocument xDoc = new XDocument(
                new XElement("ROOT",
                    new XAttribute("YEAR", "2008"),
                    new XAttribute("TOTAL", "2"),
                    new XElement("NODE_01"),
                    new XElement("NODE_02")
                )
            );

            XElement myRoot = xDoc.Element("ROOT");

            myRoot.SetAttributeValue("YEAR", 2009);		// YEARשנה מאפיין 
            myRoot.SetAttributeValue("LANG", "CSharp");	// הוסף מאפיין חדש 
            
            Console.WriteLine(xDoc);

        }

        static void sample9()
        {
            XDocument xDoc = new XDocument(
                new XDeclaration("1.0", "utf-8", "yes"),
                new XComment("This is a comment"),
                new XProcessingInstruction("xml-stylesheet",
                            @"href=""stories.css"", type=""text/css"""),

                new XElement("ROOT",
                    new XElement("NODE_01"),
                    new XElement("NODE_02")
                )
            );

            Console.WriteLine(xDoc);
        }

        static void sample10()
        {
            XDocument xd = new XDocument(
                new XElement("MyElements",
                    new XElement("first",
                        new XAttribute("color", "red"),
                        new XAttribute("size", "small")),
                    new XElement("second",
                        new XAttribute("color", "red"),
                        new XAttribute("size", "medium")),
                    new XElement("third",
                        new XAttribute("color", "blue"),
                        new XAttribute("size", "large"))));

            Console.WriteLine(xd);
            xd.Save("MyLinqSample.xml");

        }

        static void sample11()
        {
            XDocument xd = XDocument.Load("MyLinqSample.xml");  // טען את המסמך
            XElement myRoot = xd.Element("MyElements");         // קבל את השורש

            // בחר אלמנטים בעלי אורך של חמש אותיות
            var fiveLetterWords = from e in myRoot.Elements()
                                  where e.Name.ToString().Length == 5
                                  select e;

            foreach (XElement x in fiveLetterWords)
                Console.WriteLine(x.Name.ToString());

            Console.WriteLine();
            foreach (XElement x in fiveLetterWords)
                Console.WriteLine("Name: {0}, color: {1}, size: {2}",
                                    x.Name,
                                    x.Attribute("color").Value,
                                    x.Attribute("size").Value);

        }

        static void sample12()
        {
            XDocument xd = XDocument.Load("MyLinqSample.xml");  // טען את המסמך
            XElement myRoot = xd.Element("MyElements");         // קבל את השורש

            var values = from e in myRoot.Elements()
                         select new { e.Name, color = e.Attribute("color") };


            foreach (var x in values)
                Console.WriteLine(x);

            Console.WriteLine();
            foreach (var x in values)
                Console.WriteLine("{0, -6}, color: {1, -7}", x.Name, x.color.Value);

        }
    }
}
